local FE = ...

for key,value in pairs(FCconfig["profile"]["resources"]) do
	FE:register({
		DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
		Id = "FE_BUILDING_FUNCTION_INFINITE_"..key,
		Name = "FE_BUILDING_FUNCTION_INFINITE_"..key.."_NAME",
		ResourceGenerated = key,
		IsForConsumer = true,
		IsInfinite = true
	})
end

for key,value in pairs(FCconfig["profile"]["buildings"]) do
	if (value["buildingParts"] ~= nill) then
		for key,value in pairs (value["buildingParts"]) do
			local t={}
			local st=""
			local c = 0
			local fListT = {}
			local gfListT ={}
        		for str in string.gmatch(key, "([^_]+)") do
                		table.insert(t, str)
        		end
			for key,value in pairs(t) do 
				if (c > 1) then
					st = st.."_"..value
				end
				c = c + 1
			end
			if (value["buildingFunction"] ~= nill) then
				for key,value in pairs(value["buildingFunction"]["functionList"]) do
					if (value) then
						table.insert(fListT, key)
					end
				end
				for key,value in pairs(FCconfig["profile"]["buildingFunctions"]["functionList"]) do
					if (value) then
						table.insert(gfListT, key)
					end
				end
				if (value["buildingFunction"]["useGlobalList"])then
					FE:register({
						DataType = "BUILDING_FUNCTION_LIST",
						Id = "FE_BUILDING_FUNCTION_LIST"..st,
						AssetFunctionList = gfListT
					})
				else
					FE:register({
						DataType = "BUILDING_FUNCTION_LIST",
						Id = "FE_BUILDING_FUNCTION_LIST"..st,
						AssetFunctionList = fListT
					})
				end
				FE:register({
					DataType = "BUILDING_FUNCTION_ASSIGNABLE",
					Id = "FE_BUILDING_FUNCTION_ASSIGNABLE"..st,
					Name = "FE_BUILDING_FUNCTION_ASSIGNABLE"..st.."_NAME",
					AuthorizedFunctionList = "FE_BUILDING_FUNCTION_LIST"..st
				})
				if value["buildingFunction"]["activeFunction"] ~= "default" then
					FE:override({
						Id = key,
						BuildingFunction = value["buildingFunction"]["activeFunction"]
					})
				end
			end
		end
	end
end

local vanillaFunctionList = {"BUILDING_FUNCTION_STUDY_ROOM","BUILDING_FUNCTION_BREWERY","BUILDING_FUNCTION_HOP_FARM","BUILDING_FUNCTION_GOODS_MARKET","BUILDING_FUNCTION_LUXURY_MARKET","BUILDING_FUNCTION_FOOD_MARKET","BUILDING_FUNCTION_BAKERY","BUILDING_FUNCTION_BEEKEEPING","BUILDING_FUNCTION_BERRY_TABLE","BUILDING_FUNCTION_BLACKSMITH","BUILDING_FUNCTION_CHEESE_MAKER","BUILDING_FUNCTION_COAL_HUT","BUILDING_FUNCTION_COOPERAGE","BUILDING_FUNCTION_FORESTER","BUILDING_FUNCTION_HERBS_GARDEN","BUILDING_FUNCTION_HUNTERS_HUT","BUILDING_FUNCTION_IRON_MINE","BUILDING_FUNCTION_IRON_SMELTER","BUILDING_FUNCTION_SAWMILL","BUILDING_FUNCTION_STONECUTTER_CAMP","BUILDING_FUNCTION_STONEMASON_HUT","BUILDING_FUNCTION_TAILOR_WORKSHOP","BUILDING_FUNCTION_WEAPONSMITH","BUILDING_FUNCTION_WEAVER_HUT","BUILDING_FUNCTION_WINDMILL","BUILDING_FUNCTION_WINERY","BUILDING_FUNCTION_WOODCUTTER","BUILDING_FUNCTION_WHEAT_FARM","BUILDING_FUNCTION_FISHING_HUT","BUILDING_FUNCTION_KITCHEN","BUILDING_FUNCTION_DAIRY_FARM","BUILDING_FUNCTION_SHEEP_FARM","BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM","BUILDING_FUNCTION_WELL","BUILDING_FUNCTION_WOODEN_KEEP","BUILDING_FUNCTION_GRANARY","BUILDING_FUNCTION_WAREHOUSE"}
for key,value in pairs(vanillaFunctionList) do
	FE:override({
		Id = value,
		Name = "VANILLA_"..value.."_NAME"
	})
end

local function functionOverride(bfunction, settings)
if not string.find(bfunction,"VINEYARD") then

	if settings["Has Maximum Instance"] ~= "default" and settings["Has Maximum Instance"] ~= nil then
		
		FE:override({
			Id = bfunction,
			HasMaximumInstance = settings["Has Maximum Instance"]
		})
	end
	if settings["max Quantity"] ~= "default" and settings["max Quantity"] ~= nil then
		FE:override({
			Id = bfunction,
			MaxQuantity = settings["max Quantity"]
		})
	end
	if settings["Amount Maximum Instance"] ~= "default" and settings["Amount Maximum Instance"] ~= nil then
		FE:override({
			Id = bfunction,
			MaximumInstanceAllowed = settings["Amount Maximum Instance"]
		})
	end

	if settings["initialInventory"] ~= nil and next(settings["initialInventory"]) ~= nil then
		FE:override({
			Id = "DEFAULT_VILLAGE_CENTER_INVENTORY",
			Collection = settings["initialInventory"] 
		})
	end

	if settings["UpkeepPerCapacity"] ~= nil and next(settings["UpkeepPerCapacity"]) ~= nil then
		FE:override({
			Id = bfunction,
			UpkeepPerCapacity = settings["UpkeepPerCapacity"] 
		})
	end

	if settings["Worker Capacity"] ~= "default" and settings["Worker Capacity"] ~= nil then
		FE:override({
			Id = bfunction,
			WorkerCapacity = settings["Worker Capacity"] 
		})
	end

	if settings["UpkeepPerWorker"]~=nil and next(settings["UpkeepPerWorker"]) ~= nil then
		FE:override({
			Id = bfunction,
			UpkeepPerWorker = settings["UpkeepPerWorker"] 
		})
	end
	if settings["InputInventoryCapacity"]~=nil and next(settings["InputInventoryCapacity"]) ~= nil then
		FE:override({
			Id = bfunction,
			InputInventoryCapacity = settings["InputInventoryCapacity"] 
		})
	end
	if settings["ResourcesNeeded"]~=nil and next(settings["ResourcesNeeded"]) ~= nil then
		FE:override({
			Id = bfunction,
			ResourceListNeeded = settings["ResourcesNeeded"] 
		})
	end

	if settings["ResourcesProduced"]~=nil and next(settings["ResourcesProduced"]) ~= nil then
		FE:override({
			Id = bfunction,
			ResourceProduced = settings["ResourcesProduced"] 
		})
	end
	if settings["Stay Duration"] ~= "default" and settings["Stay Duration"] ~= nil then
		FE:override({
			Id = bfunction,
			TimeInLounge = settings["Stay Duration"] 
		})
	end
	if settings["Splendor Multiplier"] ~= "default" and settings["Splendor Multiplier"] ~= nil then
		FE:override({
			Id = bfunction,
			SplendorMultiplier = settings["Splendor Multiplier"] 
		})
	end
	if settings["Slot Capacity"] ~= "default" and settings["Slot Capacity"] ~= nil then
		FE:override({
			Id = bfunction,
			CapacityPerSlot = settings["Slot Capacity"] 
		})
	end
	if settings["Socket Capacity"] ~= "default" and settings["Socket Capacity"] ~= nil then
		FE:override({
			Id = bfunction,
			SocketCapacity = settings["Socket Capacity"] 
		})
	end
	if settings["Tax Amount"] ~= "default" and settings["Tax Amount"] ~= nil then
		FE:override({
			Id = bfunction,
			DefaultTax = settings["Tax Amount"] 
		})
	end
	if settings["Harvest Steps"] ~= "default" and settings["Harvest Steps"] ~= nil then
		FE:override({
			Id = bfunction,
			HarvestStepsCount = settings["Harvest Steps"] 
		})
	end
	if settings["Planting Steps"] ~= "default" and settings["Planting Steps"] ~= nil then
		FE:override({
			Id = bfunction,
			PlantingStepsCount = settings["Planting Steps"] 
		})
	end
	if settings["Amount Per Harvest"] ~= "default" and settings["Amount Per Harvest"] ~= nil then
		FE:override({
			Id = bfunction,
			ResourceValuePerGather = settings["Amount Per Harvest"] 
		})
	end
	if settings["Capacity"] ~= "default" and settings["Capacity"] ~= nil then
		FE:override({
			Id = bfunction,
			Capacity = settings["Capacity"] 
		})
	end
end
end

for key,value in pairs(FCconfig["profile"]["buildingFunctions"]) do
if not string.find(key,"List") then
	for key1,value1 in pairs(value) do

		if (value1 ~= nil) then
			if (string.find(next(value1),"FUNCTION")) then
				for key2, value2 in pairs(value1) do
					if value2 ~= nil then
						--FE:log(key2.." "..next(value2))
						functionOverride(key2,value2)
					end
				end
			else
				--FE:log(key1.." "..next(value1))
				functionOverride(key1,value1)
			end
		end
	end
end
end
			
