local deforestation = ...

deforestation:registerAssetId("models/cube.fbx/Prefab/cube", "PREFAB_DEFORESTATION_CUBE")

deforestation:registerAssetProcessor("models/cube.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

deforestation:registerPrefabComponent("models/cube.fbx/Prefab/cube", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZoneData = {Polygon = polygon.createCircle(50,{0,0},6)}
})

deforestation:register({
	DataType = "BUILDING_PART",
	Id = "DEFORESTATION_CUBE_PART",
	Name = "DEFORESTATION_CUBE_PART_NAME",
	Description = "DEFORESTATION_CUBE_PART_DESC",
	Category = "CORE",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DEFORESTATION_CUBE"
	}
})

deforestation:register({
	DataType = "MONUMENT",
	Id = "DEFORESTATION_MONUMENT",
	Name = "DEFORESTATION_MONUMENT_NAME",
	Description = "DEFORESTATION_MONUMENT_DESC",
	BuildingType = "MONUMENT",
	BuildingPartSetList = {
		{
			Name = "LIST_DEFORESTATION_NAME",
	        BuildingPartList = {
				"DEFORESTATION_CUBE_PART"
			}
		}
    },
	RequiredPartList = {
		{ Category = "CORE", Quantity = 0 }
	},
    IsEditable = true,
	IsClearTrees = true
})